Index: src/northbridge/via/vx800/vx800_lpc.c
===================================================================
--- src/northbridge/via/vx800/vx800_lpc.c	(Revision 4427)
+++ src/northbridge/via/vx800/vx800_lpc.c	(Arbeitskopie)
@@ -23,46 +23,46 @@
 #include <device/pci.h>
 #include <device/pci_ops.h>
 #include <device/pci_ids.h>
-
 #include <pc80/mc146818rtc.h>
 #include <pc80/keyboard.h>
 #include <pc80/i8259.h>
 #include "vx800.h"
 #include "chip.h"
+#include "vx800_pci_io_modify_ops.h"
 
-static const unsigned char pciIrqs[4] = { 0xa, 0x9, 0xb, 0xa };
+static const unsigned char pciIrqs[4] = {0xa, 0x9, 0xb, 0xa};
 
-static const unsigned char vgaPins[4] = { 'A', 'B', 'C', 'D' };	//only INTA
+static const unsigned char vgaPins[4] = { 'A', 'B', 'C', 'D' };//only INTA
 
-static const unsigned char slotPins[4] = { 'A', 'A', 'A', 'A' };	//all 4
+static const unsigned char slotPins[4] = { 'A', 'A', 'A', 'A'};//all 4
 
-static const unsigned char usbdevicePins[4] = { 'A', 'B', 'C', 'D' };	//only INTA
-static const unsigned char sdioPins[4] = { 'A', 'B', 'C', 'D' };	//only INTA
-static const unsigned char sd_ms_ctrl_Pins[4] = { 'B', 'C', 'D', 'A' };	//only INTA
-static const unsigned char ce_ata_nf_ctrl_Pins[4] = { 'C', 'C', 'D', 'A' };	//only INTA
-static const unsigned char idePins[4] = { 'B', 'C', 'D', 'A' };	//only INTA
+static const unsigned char usbdevicePins[4] = { 'A', 'B', 'C', 'D' };//only INTA
+static const unsigned char sdioPins[4] = { 'A', 'B', 'C', 'D' };//only INTA
+static const unsigned char sd_ms_ctrl_Pins[4] = { 'B', 'C', 'D', 'A' };//only INTA
+static const unsigned char ce_ata_nf_ctrl_Pins[4] = { 'C', 'C', 'D', 'A' };//only INTA
+static const unsigned char idePins[4] = { 'B', 'C', 'D', 'A' };//only INTA
 
-static const unsigned char usbPins[4] = { 'A', 'B', 'C', 'D' };	//all 4 
+static const unsigned char usbPins[4] = { 'A', 'B', 'C', 'D' };//all 4 
 
-static const unsigned char hdacaudioPins[4] = { 'B', 'C', 'D', 'A' };	//only INTA 
+static const unsigned char hdacaudioPins[4] = { 'B', 'C', 'D', 'A' };//only INTA 
 
 static unsigned char *pin_to_irq(const unsigned char *pin)
 {
 	static unsigned char Irqs[4];
 	int i;
-	for (i = 0; i < 4; i++)
-		Irqs[i] = pciIrqs[pin[i] - 'A'];
+	for (i = 0 ; i < 4 ; i++)
+		Irqs[i] = pciIrqs[ pin[i] - 'A' ];
 
 	return Irqs;
 }
 
-static void pci_routing_fixup(struct device *dev)
+static void pci_routing_fixup(device_t dev)
 {
 	printk_info("%s: dev is %p\n", __FUNCTION__, dev);
 
 	/* set up PCI IRQ routing */
 	pci_write_config8(dev, 0x55, pciIrqs[0] << 4);
-	pci_write_config8(dev, 0x56, pciIrqs[1] | (pciIrqs[2] << 4));
+	pci_write_config8(dev, 0x56, pciIrqs[1] | (pciIrqs[2] << 4) );
 	pci_write_config8(dev, 0x57, pciIrqs[3] << 4);
 
 	/* VGA */
@@ -95,7 +95,7 @@
 
 	/* Standard usb components */
 	printk_info("setting usb1-2\n");
-//      pci_assign_irqs(0, 0x10, pin_to_irq(usbPins));
+	//	pci_assign_irqs(0, 0x10, pin_to_irq(usbPins));
 
 	/* sound hardware */
 	printk_info("setting hdac audio\n");
@@ -104,34 +104,110 @@
 	printk_spew("%s: DONE\n", __FUNCTION__);
 }
 
+#define R_SB_MULTI_FUNCTION_SELECT_1  0xE4
+#define R_SB_CX_STATE_BREAK_EVENT_ENABLE_1  0xE6
+#define PMIO_PROCESSOR_CONTROL  0x26
+#define R_SB_PCI_ARBITRATION_2      0x76
+#define R_SB_AUTO_SWITCH_P_STATE        0x8A
+
+void InitCPUCStatueSupport(device_t dev)
+{
+	u8 Mask, Value;
+
+	// Config Cx State
+	// Now it is C2 & C4 Up Down Mode
+	Mask = 0xFF;
+	Value = 0x30;
+	pci_modify_config8(dev, R_SB_CX_STATE_BREAK_EVENT_ENABLE_1, Mask, Value);//SB_LPC_REG
+
+	Mask = 0xFF;
+	Value = 0x1F;
+	io_modify_config8(VX800_ACPI_IO_BASE+PMIO_PROCESSOR_CONTROL, Mask, Value);
+
+	Mask = 0x00;
+	Value = 0x80;
+	device_t dev1;
+	dev1 = dev_find_device(PCI_VENDOR_ID_VIA, 
+						PCI_DEVICE_ID_VIA_VX800_SB_VLINK, 0);
+	if(dev1)
+	pci_modify_config8(dev1, R_SB_PCI_ARBITRATION_2, Mask, Value);//SB_VLINK_REG
+
+	Mask = 0xFF;
+	Value = 0x00;
+	pci_modify_config8(dev, R_SB_MULTI_FUNCTION_SELECT_1, Mask, Value);//SB_VLINK_REG
+
+	Mask = 0xFF;
+	Value = 0x1F;
+	pci_modify_config8(dev, R_SB_AUTO_SWITCH_P_STATE, Mask, Value);//SB_VLINK_REG
+}
+
+extern u8 acpi_slp_type;
 void setup_pm(device_t dev)
 {
 	u16 tmp;
+
+	// Power Management
+	pci_modify_config8(dev, 0x80, 0x00, 0x20);
+	pci_modify_config8(dev, 0x8C, 0x02, 0x00);
+	pci_modify_config8(dev, 0x8D, 0x00, 0x18);
+
+	//Miscellaneous Configuration 1
+	pci_modify_config8(dev, 0x94, 0xF0, 0x28);
+	pci_modify_config8(dev, 0x95, 0x00, 0xC1);
+	pci_modify_config8(dev, 0x96, 0xFF, 0x10);
+	pci_modify_config8(dev, 0x97, 0x00, 0xB2);
+
+	//Voltage Change Function Enable
+	pci_modify_config8(dev, 0x9F, 0x00, 0x21);
+	//Internal PCIe and NM PLL Control
+	pci_modify_config8(dev, 0xE2, 0x00, 0xEA);
+
+	pci_modify_config8(dev, 0xE7, 0x00, 0x80);
+
+
+	u8 Mask, Value;
+	// Set SCI IRQ and its level trigger
+	Mask = 0x0F;
+	Value = 0x09;
+	pci_modify_config8(dev, 0x82, Mask, Value);
+
+	Mask = 0x02;
+	Value = 0x02;
+	io_modify_config8(0x4d1, Mask, Value);
+
+	// Enable ACPI
+	Mask = 0x01; 
+	Value = 0x01;
+	io_modify_config8(VX800_ACPI_IO_BASE+0x04, Mask, Value);
+
+	InitCPUCStatueSupport(dev);
+
+
 	/* Debounce LID and PWRBTN# Inputs for 16ms. */
 	pci_write_config8(dev, 0x80, 0x20);
 
 	/* Set ACPI base address to IO VX800_ACPI_IO_BASE */
-	pci_write_config16(dev, 0x88, VX800_ACPI_IO_BASE | 1);
+	pci_write_config16(dev, 0x88, VX800_ACPI_IO_BASE|1);
 
 	/* set ACPI irq to 9 */
 	pci_write_config8(dev, 0x82, 0x49);
 
 	/* Primary interupt channel, define wake events 0=IRQ0 15=IRQ15 1=en. */
-//      pci_write_config16(dev, 0x84, 0x30f2);
-	pci_write_config16(dev, 0x84, 0x609a);	// 0x609a??
+	//	pci_write_config16(dev, 0x84, 0x30f2);
+	pci_write_config16(dev, 0x84, 0x609a); // 0x609a??
 
 	/* SMI output level to low, 7.5us throttle clock */
 	pci_write_config8(dev, 0x8d, 0x18);
 
 	/* GP Timer Control 1s */
 	pci_write_config8(dev, 0x93, 0x88);
-
+	
 	/* Power Well */
 	pci_write_config8(dev, 0x94, 0x20);	// 0x20??
 
 	/* 7 = stp to sust delay 1msec
-	 * 6 = SUSST# Deasserted Before PWRGD for STD
-	 */
+         * 6 = SUSST# Deasserted Before PWRGD for STD
+         */
 	pci_write_config8(dev, 0x95, 0xc0);	// 0xc1??
 
 	/* Disable GP2 & GP3 Timer */
@@ -156,6 +232,9 @@
 	outw(0xffff, VX800_ACPI_IO_BASE + 0x28);
 	outl(0xffffffff, VX800_ACPI_IO_BASE + 0x30);
 
+	// Enable Soft Resume
+	outw(inw(VX800_ACPI_IO_BASE+0x04)|0x8000, VX800_ACPI_IO_BASE+0x04);
+
 	/* Disable SCI on GPIO. */
 	outw(0x0, VX800_ACPI_IO_BASE + 0x22);
 
@@ -178,6 +257,7 @@
 	outb(0x0, VX800_ACPI_IO_BASE + 0x42);
 
 	tmp = inw(VX800_ACPI_IO_BASE + 0x04);
+	acpi_slp_type = ((tmp & (7 << 10)) >> 10) == 1 ? 3 : 0 ;	
 	/* SCI is generated for RTC/pwrBtn/slpBtn. */
 	tmp |= 1;
 	outw(tmp, VX800_ACPI_IO_BASE + 0x04);
@@ -198,52 +278,117 @@
 */
 }
 
-void S3_ps2_kb_ms_wakeup(struct device *dev)
+void S3_ps2_kb_ms_wakeup(device_t dev)
 {
 	u8 enables;
 	enables = pci_read_config8(dev, 0x51);
 	enables |= 2;
 	pci_write_config8(dev, 0x51, enables);
-
+	
 	outb(0xe0, 0x2e);
-	outb(0x0b, 0x2f);	//if 09,then only support kb wakeup
+	outb(0x0b, 0x2f);//if 09,then only support kb wakeup
 
-	outb(0xe1, 0x2e);	//set any key scan code can wakeup
+	outb(0xe1, 0x2e);//set any key scan code can wakeup
 	outb(0x00, 0x2f);
-
-	outb(0xe9, 0x2e);	//set any mouse scan code can wakeup
+	
+	outb(0xe9, 0x2e);//set any mouse scan code can wakeup
 	outb(0x00, 0x2f);
 
 	enables &= 0xd;
 	pci_write_config8(dev, 0x51, enables);
 
-	outb(inb(VX800_ACPI_IO_BASE + 0x02) | 0x20, VX800_ACPI_IO_BASE + 0x02);	//ACPI golabe enable for sci smi trigger
-	outw(inw(VX800_ACPI_IO_BASE + 0x22) | 0x204, VX800_ACPI_IO_BASE + 0x22);	//ACPI SCI on Internal KBC PME and mouse PME  
+	outb(inb(VX800_ACPI_IO_BASE+0x02)|0x20, VX800_ACPI_IO_BASE+0x02);// ACPI golabe enable for sci smi trigger
+	outw(inw(VX800_ACPI_IO_BASE+0x22)|0x204, VX800_ACPI_IO_BASE+0x22);// ACPI SCI on Internal KBC and mouse PME
+}
 
+void S3_usb_wakeup(device_t dev)
+{
+	outw(inw(VX800_ACPI_IO_BASE+0x22)|0x4000, VX800_ACPI_IO_BASE+0x22);//SCI on USB PME
 }
 
-void S3_usb_wakeup(struct device *dev)
+void S3_lid_wakeup(device_t dev)
 {
-	outw(inw(VX800_ACPI_IO_BASE + 0x22) | 0x4000, VX800_ACPI_IO_BASE + 0x22);	//SCI on USB PME
+	outw(inw(VX800_ACPI_IO_BASE+0x22)|0x800, VX800_ACPI_IO_BASE+0x22);//SCI on LID PME
 }
 
-void S3_lid_wakeup(struct device *dev)
+#define HPET_ENABLE_BIT			0x80
+#define R_SB_HPET_CONTROL		0x68
+#define HPET_BASE_ADDRESS		0xFED0      // 0xFED00000
+#define R_SB_HPET_ADDRESS		0x69
+void HpetInit(device_t dev)
 {
-	outw(inw(VX800_ACPI_IO_BASE + 0x22) | 0x800, VX800_ACPI_IO_BASE + 0x22);	//SCI on LID PME
+	pci_write_config8(dev, R_SB_HPET_CONTROL, HPET_ENABLE_BIT);
+	pci_write_config16(dev, R_SB_HPET_ADDRESS+1, HPET_BASE_ADDRESS);
 }
 
+void WriteSbApicIndexedReg(u8 Idx, u32 Data)
+{
+	u32 Data32;
+	u32 ApicIdxAdr = VX800_APIC_SB_BASE;
+	u32 ApicDataAdr = VX800_APIC_SB_BASE + VX800_APIC_SB_DATA_OFFSET;
+	* ((u8 *)ApicIdxAdr)=Idx;
+	Data32=( * ((u32 *)ApicDataAdr));//this read is needed when write APIC ID ,dont know why.
+	Data32 = Data;
+	* ((u32 *)ApicDataAdr)=Data32;
+}
+
+void SbApicMmioRegInit(void)
+{
+	u32 Offset;
+	WriteSbApicIndexedReg(3, 1);
+	WriteSbApicIndexedReg(0, 4);
+	for(Offset = 0x10; Offset < VX800_APIC_SB_ENTRY_NUMBER; Offset += 2){
+		WriteSbApicIndexedReg(Offset + 1, 0);
+		WriteSbApicIndexedReg(Offset, 0x10000);
+	}
+}
+
+void vx800_ApicInit(device_t dev)
+{
+	device_t dev1;
+	pci_modify_config8(dev, 0x4D, 0x04, 0x00);
+	pci_modify_config8(dev, 0x5B, 0x0E, 0x00);
+	pci_modify_config8(dev, 0x6C, 0x08, 0x00);
+	pci_modify_config8(dev, 0x58, 0x00, 0x40);
+	dev1 = dev_find_device(PCI_VENDOR_ID_VIA, 
+						PCI_DEVICE_ID_VIA_VX800_SB_VLINK, 0);
+	if(dev1)	
+	pci_modify_config8(dev1, 0x74, 0x00, 0x04);
+	//pci_modify_config8(dev1, 0x7C, 0x00, 0x7F);
+
+	SbApicMmioRegInit();
+}
+
 /* This looks good enough to work, maybe */
-static void vx800_sb_init(struct device *dev)
+static void vx800_sb_init(device_t dev)
 {
 	unsigned char enables;
 
+	/*BusControllerInit begin*/
+	pci_modify_config8(dev, 0x42, 0xF8, 0xF0);      //  ENLBUF, GINTREN, FLUSHEN, RBRSTRD
+	pci_modify_config8(dev, 0x43, 0x0F, 0x0B);      //  RENDTX, ENWBTO, ENRBTO
+	//pci_modify_config8(dev, 0x46, 0x00, 0x10);     // It is related to INTH#
+	//pci_modify_config8(dev, 0x48, 0x00, 0x0C);      //RMRPW, RIRPW 
+	//pci_modify_config8(dev, 0x58, 0x00, 0x01);    //RTC Rx32 Map to Centrury Byte//booting OS fail if set.
+	//pci_modify_config8(dev, 0x40, 0x00, 0x02);    // RDMEGAS
+	pci_modify_config8(dev, 0x4C, 0xC0, 0x40); 
+	pci_modify_config8(dev, 0x5B, 0x00, 0x51);   // modify from 0x53 to 0x51
+	pci_modify_config8(dev, 0x67, 0x03, 0x01); 
+  
+	/*BusControllerInit end*/
+
+	HpetInit(dev);
+
+	vx800_ApicInit(dev);
+
+
 	// enable the internal I/O decode
 	enables = pci_read_config8(dev, 0x6C);
 	enables |= 0x80;
 	pci_write_config8(dev, 0x6C, enables);
 
 	// Map 4MB of FLASH into the address space
-//      pci_write_config8(dev, 0x41, 0x7f);
+	//	pci_write_config8(dev, 0x41, 0x7f);
 
 	// Set bit 6 of 0x40, because Award does it (IO recovery time)
 	// IMPORTANT FIX - EISA 0x4d0 decoding must be on so that PCI
@@ -261,7 +406,7 @@
 	pci_write_config8(dev, 0x4c, 0x44);
 
 	/* ROM memory cycles go to LPC. */
-	pci_write_config8(dev, 0x59, 0x80);
+        pci_write_config8(dev, 0x59, 0x80);
 
 	/* Set 0x5b to 0x01 to match Award */
 	//pci_write_config8(dev, 0x5b, 0x01);
@@ -274,9 +419,9 @@
 
 	/* Set 0x58 to 0x42 APIC and RTC. */
 	//pci_write_config8(dev, 0x58, 0x42); this cmd cause the irq0 can not be triggerd,since bit 5 was set to 0.
-	enables = pci_read_config8(dev, 0x58);
-	enables |= 0x41;	//
-	pci_write_config8(dev, 0x58, enables);
+	enables=pci_read_config8(dev, 0x58); 
+	enables|=0x40;//
+	pci_write_config8(dev, 0x58,enables); 
 
 	/* Set bit 3 of 0x4f to match award (use INIT# as cpu reset) */
 	enables = pci_read_config8(dev, 0x4f);
@@ -307,9 +452,9 @@
 	struct resource *resource;
 	pci_dev_read_resources(dev);
 	resource = new_resource(dev, 1);
-	resource->flags |=
-	    IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO |
-	    IORESOURCE_STORED;
+	resource->flags |= 
+		IORESOURCE_FIXED | IORESOURCE_ASSIGNED | IORESOURCE_IO | 
+		IORESOURCE_STORED;
 	resource->size = 2;
 	resource->base = 0x2e;
 
@@ -318,13 +463,13 @@
 void vx800_set_resources(device_t dev)
 {
 	struct resource *resource;
-	resource = find_resource(dev, 1);
+	resource = find_resource(dev,1);
 	resource->flags |= IORESOURCE_STORED;
 	pci_dev_set_resources(dev);
 }
 
 void vx800_enable_resources(device_t dev)
-{
+ {
 	/* vx800 is not a pci bridge and has no resources of its own (other than
 	   standard PC i/o addresses). however it does control the isa bus and so
 	   we need to manually call enable childrens resources on that bus */
@@ -333,21 +478,24 @@
 	enable_childrens_resources(dev);
 }
 
-static void southbridge_init(struct device *dev)
-{
+
+
+static void lpc_init(device_t dev)
+{ 
 	printk_debug("vx800 sb init\n");
 	vx800_sb_init(dev);
 	pci_routing_fixup(dev);
 
-	setup_i8259();		// make sure interupt controller is configured before keyboard init
+	setup_i8259();   // make sure interupt controller is configured before keyboard init
 
-	/* turn on keyboard and RTC, no need to visit this reg twice */
+  	/* turn on keyboard and RTC, no need to visit this reg twice */
 	init_pc_keyboard(0x60, 0x64, 0);
-	printk_debug
-	    ("ps2 usb lid, you  set who can wakeup system from s3 sleep\n");
-	S3_ps2_kb_ms_wakeup(dev);
-	S3_usb_wakeup(dev);
 
+	printk_debug("ps2 usb lid, you  set who can wakeup system from s3 sleep\n");		
+
+	S3_ps2_kb_ms_wakeup(dev);	
+	S3_usb_wakeup(dev); 
+
 /*	enable acpi cpu c3 state. (c2 state need not do anything.)
 	#1
 		fadt->pm2_cnt_blk = 0x22;//to support cpu-c3
@@ -355,7 +503,7 @@
 		fadt->p_lvl3_lat = 0x320;//
 		fadt->pm2_cnt_len = 1;//to support cpu-c3
 	#2
-		ssdt? ->every cpu has a P_BLK address. set it to 0x10 (so that "Read Processor Level3 register(PMIORx15<7:0>) to enter C3 state"---VIA vx800 P SPEC )
+		ssdt? ->every cpu has a P_BLK address. set it to 0x10 (so that "Read Processor Level3 register(PMIORx15<7:0>) to enter C3 state")
        #3    write 0x17 in to PMIO=VX800_ACPI_IO_BASE + 0x26, following the describtion in the P-spec. 
 	       1  enable SLP# asserts in C3 state  PMIORx26<1> =1
 		2    enable CPUSTP# asserts in C3 state;  PMIORx26<2> =1
@@ -368,20 +516,40 @@
 		PMIORx26<0> =0
 		6  Read Processor Level3 register(PMIORx15<7:0>) to enter C3 state  PMIORx15 
 	*/
-	outb(0x17, VX800_ACPI_IO_BASE + 0x26);
+	outb(0x17, VX800_ACPI_IO_BASE + 0x26);	
 
 }
 
+void lpc_enable(device_t dev)
+{	
+	pci_modify_config8(dev, 0x41, 0x40, 0x40);
+
+	// Acpi init registers
+	pci_modify_config8(dev, 0x40, 0x44, 0x44); //  Enable I/O Recovery Time,  4D0/4D1 Support
+	pci_modify_config8(dev, 0x4E, 0x00, 0x08);// Enable RTC port 74/75
+	pci_modify_config8(dev, 0x51, 0x0D, 0x0D);// and KBC
+	pci_modify_config8(dev, 0x52, 0x0F, 0x09); // Enable Serial IRQ
+	pci_modify_config8(dev, 0x67, 0x00, 0x04); // Set FERR voltage to 1.5v
+	pci_modify_config8(dev, 0x98, 0xFF, 0x00);// Disable GP3 Timer
+
+	///// SPI-BAR.
+	//// SPI_BASE_ADDRESS = 0xFED1 0000
+	pci_modify_config8(dev, 0xBC, 0xFF, 0x00);
+	pci_modify_config8(dev, 0xBD, 0xFF, 0xD1);
+	pci_modify_config8(dev, 0xBE, 0xFF, 0xFE);	
+}
+
 static struct device_operations vx800_lpc_ops = {
-	.read_resources = vx800_read_resources,
-	.set_resources = vx800_set_resources,
+	.read_resources   = vx800_read_resources,
+	.set_resources    = vx800_set_resources,
 	.enable_resources = vx800_enable_resources,
-	.init = &southbridge_init,
-	.scan_bus = scan_static_bus,
+	.init             = &lpc_init,
+	.scan_bus         = scan_static_bus,
+	.enable	=lpc_enable,
 };
 
 static struct pci_driver lpc_driver __pci_driver = {
-	.ops = &vx800_lpc_ops,
+	.ops    = &vx800_lpc_ops,
 	.vendor = PCI_VENDOR_ID_VIA,
-	.device = PCI_DEVICE_ID_VIA_VX855_LPC,
+	.device = PCI_DEVICE_ID_VIA_VX800_LPC,
 };
Index: src/northbridge/via/vx800/timing_setting.c
===================================================================
--- src/northbridge/via/vx800/timing_setting.c	(Revision 4427)
+++ src/northbridge/via/vx800/timing_setting.c	(Arbeitskopie)
@@ -170,6 +170,7 @@
 	Tmp =
 	    (u16) ((Max * 100 + ((DramAttr->DramCyc) << 2) -
 		    1) / ((DramAttr->DramCyc) << 2));
+	Tmp += 1;
 	PRINT_DEBUG_MEM("Trcd =");
 	PRINT_DEBUG_MEM_HEX16(Tmp);
 	PRINT_DEBUG_MEM("\r");
Index: src/northbridge/via/vx800/vx800_nb_host_ctrl.c
===================================================================
--- src/northbridge/via/vx800/vx800_nb_host_ctrl.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_nb_host_ctrl.c	(Revision 0)
@@ -0,0 +1,47 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ops.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "chip.h"
+#include <arch/io.h>
+#include "vx800.h"
+
+void nb_host_ctrl_enable(device_t dev)
+{	
+	u32 subid=PCI_DEVICE_ID_VIA_VX800_NB_HOST_CTRL<<16+PCI_VENDOR_ID_VIA;
+	pci_write_config32(dev,0x2C,subid);
+}
+static struct device_operations nb_host_ctrl_ops = {
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init		  = 0,
+	.enable		  = nb_host_ctrl_enable,
+	.ops_pci	  = 0,
+};
+
+static struct pci_driver via_nb_host_ctrl_driver __pci_driver = {
+	.ops    = &nb_host_ctrl_ops,
+	.vendor = PCI_VENDOR_ID_VIA,
+	.device = PCI_DEVICE_ID_VIA_VX800_NB_HOST_CTRL,
+};
Index: src/northbridge/via/vx800/vx800.h
===================================================================
--- src/northbridge/via/vx800/vx800.h	(Revision 4427)
+++ src/northbridge/via/vx800/vx800.h	(Arbeitskopie)
@@ -34,36 +34,6 @@
 #define REV_B0 0x00
 #define REV_B2 0x01
 
-/* VGA stuff */
-#define SR_INDEX	0x3c4
-#define SR_DATA		0x3c5
-#define CRTM_INDEX	0x3b4
-#define CRTM_DATA	0x3b5
-#define CRTC_INDEX	0x3d4
-#define CRTC_DATA	0x3d5
-
-/* Memory Controller Registers */
-#define RANK0_END		0x40
-#define RANK1_END		0x41
-#define RANK2_END		0x42
-#define RANK3_END		0x43
-#define RANK0_START		0x48
-#define RANK1_START		0x49
-#define RANK2_START		0x4a
-#define RANK3_START		0x4b
-#define DDR_PAGE_CTL		0x69
-#define DRAM_REFRESH_COUNTER	0x6a
-#define DRAM_MISC_CTL		0x6b
-#define CH_A_DQS_OUTPUT_DELAY	0x70
-#define CH_A_MD_OUTPUT_DELAY	0x71
-
-/* RAM Init Commands */
-#define RAM_COMMAND_NORMAL	0x0
-#define RAM_COMMAND_NOP		0x1
-#define RAM_COMMAND_PRECHARGE	0x2
-#define RAM_COMMAND_MRS		0x3
-#define RAM_COMMAND_CBR		0x4
-
 /* IDE specific bits */
 #define IDE_MODE_REG		0x09
 #define IDE0_NATIVE_MODE	(1 << 0)
@@ -85,8 +55,8 @@
 #define VX800_ACPI_IO_BASE	0x0400
 
 #define NB_APIC_REG 0,0,5,
-#define NB_PXPTRF_REG  NB_APIC_REG
-#define NB_MSGC_REG NB_APIC_REG
+#define NB_PXPTRF_REG  NB_APIC_REG 
+#define NB_MSGC_REG NB_APIC_REG 
 #define NB_HOST_REG 0,0,2,
 #define NB_P6IF_REG NB_HOST_REG
 
@@ -107,11 +77,12 @@
 #define SB_USB2_REG 0,0x10, 2,
 #define SB_EHCI_REG 0,0x10, 4,
 
-#define VX800SB_APIC_ID			0x4
-#define VX800SB_APIC_BASE		0xfec00000ULL
-#define VX800SB_APIC_DATA_OFFSET             0x10
-#define VX800SB_APIC_ENTRY_NUMBER 0x40
 
+#define VX800_APIC_SB_ID			0x4
+#define VX800_APIC_SB_BASE		0xfec00000ULL
+#define VX800_APIC_SB_DATA_OFFSET             0x10
+#define VX800_APIC_SB_ENTRY_NUMBER 0x40
+
 #define VX800_D0F5_MMCONFIG_MBAR	0x61
 
 #endif
Index: src/northbridge/via/vx800/vx800_pci_io_modify_ops_for_auto.c
===================================================================
--- src/northbridge/via/vx800/vx800_pci_io_modify_ops_for_auto.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_pci_io_modify_ops_for_auto.c	(Revision 0)
@@ -0,0 +1,51 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#ifndef VX800_PCI_IO_MODIFY_OPS_FOR_AUTO_C
+#define  VX800_PCI_IO_MODIFY_OPS_FOR_AUTO_C 1
+
+void pci_modify_config8(device_t dev, unsigned where,u8 mask,u8 orval)
+{     
+	u8 data=pci_read_config8(dev,where);
+       data&=(~mask);
+       data|=orval;
+       pci_write_config8(dev,where,data);
+}
+void pci_modify_config16(device_t dev, unsigned where,uint16_t mask,uint16_t orval)
+{     
+	uint16_t data=pci_read_config16(dev,where);
+       data&=(~mask);
+       data|=orval;
+       pci_write_config16(dev,where,data);
+}
+void pci_modify_config32(device_t dev, unsigned where, uint32_t mask,uint32_t orval)
+{     
+	uint32_t data=pci_read_config32(dev,where);
+       data&=(~mask);
+       data|=orval;
+       pci_write_config32(dev,where,data);
+}
+void io_modify_config8(u16 where, uint8_t mask,uint8_t orval)
+{     
+	u8 data=inb(where);
+       data&=(~mask);
+       data|=orval;
+       outb(data,where);
+}
+#endif
Index: src/northbridge/via/vx800/vx800_uhci.c
===================================================================
--- src/northbridge/via/vx800/vx800_uhci.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_uhci.c	(Revision 0)
@@ -0,0 +1,59 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ops.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "chip.h"
+#include <arch/io.h>
+#include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
+void uhci_init(device_t dev)
+{
+	u8 Mask, Value;
+	u16 D16;    
+	D16 = 0;
+	pci_write_config16(dev, 0x20, D16);
+
+	// Config some Control Register
+	Mask = 0x00;
+	Value = 0x12;
+	
+	pci_modify_config8(dev, 0x41, Mask, Value);
+	Mask = 0x00;
+	Value = 0xEB;
+	pci_modify_config8(dev, 0x4B, Mask, Value);
+}
+
+static struct device_operations uhci_ops = {
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init		  = uhci_init,
+	.enable		  = 0,
+	.ops_pci	  = 0,
+};
+
+static struct pci_driver via_uhci_driver __pci_driver = {
+	.ops    = &uhci_ops,
+	.vendor = PCI_VENDOR_ID_VIA,
+	.device = PCI_DEVICE_ID_VIA_VX800_UHCI,
+};
Index: src/northbridge/via/vx800/romstrap.inc
===================================================================
--- src/northbridge/via/vx800/romstrap.inc	(Revision 4427)
+++ src/northbridge/via/vx800/romstrap.inc	(Arbeitskopie)
@@ -28,7 +28,7 @@
 __romstrap_start:
 tblpointer:
 	.long 0x55aa66cc
-	.long 0x88012554
+	.long 0x88012454
 	.long 0x77107777
 	.long 0x00770814
 
Index: src/northbridge/via/vx800/driving_setting.c
===================================================================
--- src/northbridge/via/vx800/driving_setting.c	(Revision 4427)
+++ src/northbridge/via/vx800/driving_setting.c	(Arbeitskopie)
@@ -180,7 +180,7 @@
 		pci_write_config8(MEMCTRL, 0xd5, Data);
 
 		Data = pci_read_config8(MEMCTRL, 0xd7);
-		Data &= 0xEF;	/*clear bit7 */
+		Data &= 0x7F;	/*clear bit7 */
 		if (DramAttr->RankNumChA > 2)
 			Data |= 0x80;	/*if rank number > 2 (3or4), set bit7 */
 		else
@@ -370,7 +370,7 @@
 	else if (DIMMFREQ_667 == DramAttr->DramFreq)
 		FreqId = 2;
 	else if (DIMMFREQ_800 == DramAttr->DramFreq)
-		FreqId = 4;
+		FreqId = 3;
 	else
 		FreqId = 0;
 
Index: src/northbridge/via/vx800/dev_init.c
===================================================================
--- src/northbridge/via/vx800/dev_init.c	(Revision 4427)
+++ src/northbridge/via/vx800/dev_init.c	(Arbeitskopie)
@@ -469,7 +469,7 @@
 
 	/* CL: really offset RX62[2:0] */
 	Data = pci_read_config8(MEMCTRL, 0x62);
-	CL = Data & 0x03;
+	CL = Data & 0x07;
 
 	AccessAddr = (u32) (CHA_DDR2_MRS_table[CL]);
 	if (BL)
Index: src/northbridge/via/vx800/vx800_nb_traf_ctrl.c
===================================================================
--- src/northbridge/via/vx800/vx800_nb_traf_ctrl.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_nb_traf_ctrl.c	(Revision 0)
@@ -0,0 +1,94 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
+
+extern unsigned long log2(unsigned long x);
+
+static void mmconfig_set_resources(device_t dev)
+{
+	struct resource *resource;
+	u8 reg;
+
+	resource = find_resource(dev, VX800_D0F5_MMCONFIG_MBAR);
+	if (resource) {
+		report_resource_stored(dev, resource, "<mmconfig>");
+
+		/* Remember this resource has been stored. */
+		resource->flags |= IORESOURCE_STORED;
+		pci_write_config8(dev, VX800_D0F5_MMCONFIG_MBAR,
+				  (resource->base >> 28));
+		reg = pci_read_config8(dev, 0x60);
+		reg |= 0x3;
+		/* Enable MMCONFIG decoding. */
+		pci_write_config8(dev, 0x60, reg);
+	}
+	pci_dev_set_resources(dev);
+}
+
+static void mmconfig_read_resources(device_t dev)
+{
+	struct resource *res;
+	pci_dev_read_resources(dev);
+	
+	/* Add an MMCONFIG resource. */
+	res = new_resource(dev, VX800_D0F5_MMCONFIG_MBAR);
+	res->size = 256 * 1024 * 1024;
+	res->align = log2(res->size);
+	res->gran = log2(res->size);
+	res->limit = 0xffffffff;	/* 4G */
+	res->flags = IORESOURCE_MEM;
+}
+
+void traf_ctrl_init(device_t dev)
+{
+	pci_modify_config8(dev, 0x50, 0x00, 0x00);
+	pci_modify_config8(dev, 0x54, 0x00, 0x80);
+	pci_modify_config8(dev, 0x55, 0x00, 0x04);
+	pci_modify_config8(dev, 0x58, 0x00, 0x00);
+	pci_modify_config8(dev, 0x59, 0x00, 0x02);
+	pci_modify_config8(dev, 0x5E, 0x00, 0x00);
+	pci_modify_config8(dev, 0x5F, 0x00, 0x06);
+	pci_modify_config8(dev, 0x80, 0x00, 0x18);  //Set RVC1DM, RTHBHIT, RUWRDYD, RUPRRDY1, RUWPOPHD to 1.
+	pci_modify_config8(dev, 0x82, 0x00, 0x00);  //Set RVC1RPSW, RVC1RQ1T to 1.
+	pci_modify_config8(dev, 0x83, 0x00, 0x81);
+	pci_modify_config8(dev, 0x84, 0x00, 0x28);
+	pci_modify_config8(dev, 0x85, 0x00, 0xC0);
+	pci_modify_config8(dev, 0xA3, 0x00, 0x01);   // RWAKEEN,MSGC_REG
+	//pci_modify_config8(dev, 0x64, 0x40, 0x00); //RTDNP2B32EN	
+	pci_modify_config8(dev, 0xF3, 0xFC, 0x20);
+	pci_modify_config8(dev, 0x85, 0x00, 0x00);  //RP2P1ABORT
+}
+static const struct device_operations traf_ctrl_ops = {
+	.read_resources		= mmconfig_read_resources,
+	.set_resources		= mmconfig_set_resources,
+	.init		  = traf_ctrl_init,	
+};
+
+/*NB APIC, PXPTRF and MSGC*/
+static const struct pci_driver traf_ctrl_driver __pci_driver = {
+	.ops	= &traf_ctrl_ops,
+	.vendor	= PCI_VENDOR_ID_VIA,
+	.device	= PCI_DEVICE_ID_VIA_VX800_NB_CTC,
+};
